<html>
<head>
<title>OGRE: OgreZip.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.5.3 -->
<div class="tabs">
  <ul>
    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
    <li><a href="namespaces.html"><span>Namespaces</span></a></li>
    <li><a href="classes.html"><span>Classes</span></a></li>
    <li class="current"><a href="files.html"><span>Files</span></a></li>
    <li><a href="dirs.html"><span>Directories</span></a></li>
    <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
  </ul>
</div>
<div class="nav">
<a class="el" href="dir_d6c9b501d36b850bf0bac687671293db.html">OgreMain</a>&nbsp;&raquo&nbsp;<a class="el" href="dir_f35e1e76cd4423745a1cccb1f171d4e3.html">include</a></div>
<h1>OgreZip.h</h1><a href="OgreZip_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2006 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment">Also see acknowledgements in Readme.html</span>
<a name="l00009"></a>00009 <span class="comment"></span>
<a name="l00010"></a>00010 <span class="comment">This program is free software; you can redistribute it and/or modify it under</span>
<a name="l00011"></a>00011 <span class="comment">the terms of the GNU Lesser General Public License as published by the Free Software</span>
<a name="l00012"></a>00012 <span class="comment">Foundation; either version 2 of the License, or (at your option) any later</span>
<a name="l00013"></a>00013 <span class="comment">version.</span>
<a name="l00014"></a>00014 <span class="comment"></span>
<a name="l00015"></a>00015 <span class="comment">This program is distributed in the hope that it will be useful, but WITHOUT</span>
<a name="l00016"></a>00016 <span class="comment">ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS</span>
<a name="l00017"></a>00017 <span class="comment">FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">You should have received a copy of the GNU Lesser General Public License along with</span>
<a name="l00020"></a>00020 <span class="comment">this program; if not, write to the Free Software Foundation, Inc., 59 Temple</span>
<a name="l00021"></a>00021 <span class="comment">Place - Suite 330, Boston, MA 02111-1307, USA, or go to</span>
<a name="l00022"></a>00022 <span class="comment">http://www.gnu.org/copyleft/lesser.txt.</span>
<a name="l00023"></a>00023 <span class="comment"></span>
<a name="l00024"></a>00024 <span class="comment">You may alternatively use this source under the terms of a specific version of</span>
<a name="l00025"></a>00025 <span class="comment">the OGRE Unrestricted License provided you have obtained such a license from</span>
<a name="l00026"></a>00026 <span class="comment">Torus Knot Software Ltd.</span>
<a name="l00027"></a>00027 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00028"></a>00028 <span class="comment">*/</span>
<a name="l00029"></a>00029 <span class="preprocessor">#ifndef __Zip_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#define __Zip_H__</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 <span class="preprocessor">#include "<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>"</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="preprocessor">#include "<a class="code" href="OgreArchive_8h.html">OgreArchive.h</a>"</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include "<a class="code" href="OgreArchiveFactory_8h.html">OgreArchiveFactory.h</a>"</span>
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="comment">// Forward declaration for zziplib to avoid header file dependency.</span>
<a name="l00038"></a><a class="code" href="OgreZip_8h.html#8cee87e0d5584ff66b56196eec9758c4">00038</a> <span class="keyword">typedef</span> <span class="keyword">struct </span>zzip_dir     <a class="code" href="OgreZip_8h.html#8cee87e0d5584ff66b56196eec9758c4">ZZIP_DIR</a>;
<a name="l00039"></a><a class="code" href="OgreZip_8h.html#83aee2653632d452e58ac776fde409ea">00039</a> <span class="keyword">typedef</span> <span class="keyword">struct </span>zzip_file    <a class="code" href="OgreZip_8h.html#83aee2653632d452e58ac776fde409ea">ZZIP_FILE</a>;
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 <span class="keyword">namespace </span>Ogre {
<a name="l00042"></a>00042 
<a name="l00049"></a><a class="code" href="classOgre_1_1ZipArchive.html">00049</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1ZipArchive.html" title="Specialisation of the Archive class to allow reading of files from a zip format source...">ZipArchive</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1Archive.html" title="Archive-handling class.">Archive</a> 
<a name="l00050"></a>00050     {
<a name="l00051"></a>00051     <span class="keyword">protected</span>:
<a name="l00053"></a><a class="code" href="classOgre_1_1ZipArchive.html#c95bbd525401e829a38652abdb255003">00053</a>         <a class="code" href="OgreZip_8h.html#8cee87e0d5584ff66b56196eec9758c4">ZZIP_DIR</a>* mZzipDir;
<a name="l00055"></a>00055         <span class="keywordtype">void</span> checkZzipError(<span class="keywordtype">int</span> zzipError, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; operation) <span class="keyword">const</span>;
<a name="l00057"></a><a class="code" href="classOgre_1_1ZipArchive.html#33516e5d5f732b34a58413df6b2d5a06">00057</a>         <a class="code" href="namespaceOgre.html#d87d047326eb42275e3f24117fe63481">FileInfoList</a> mFileList;
<a name="l00058"></a>00058     <span class="keyword">public</span>:
<a name="l00059"></a>00059         <a class="code" href="classOgre_1_1ZipArchive.html" title="Specialisation of the Archive class to allow reading of files from a zip format source...">ZipArchive</a>(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; archType );
<a name="l00060"></a>00060         ~<a class="code" href="classOgre_1_1ZipArchive.html" title="Specialisation of the Archive class to allow reading of files from a zip format source...">ZipArchive</a>();
<a name="l00062"></a><a class="code" href="classOgre_1_1ZipArchive.html#4bb33f4e21a4ca69049eae7c6fc5b6e5">00062</a>         <span class="keywordtype">bool</span> isCaseSensitive(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="keyword">false</span>; }
<a name="l00063"></a>00063 
<a name="l00065"></a>00065         <span class="keywordtype">void</span> load();
<a name="l00067"></a>00067         <span class="keywordtype">void</span> unload();
<a name="l00068"></a>00068 
<a name="l00070"></a>00070         <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is...">DataStreamPtr</a> open(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; filename) <span class="keyword">const</span>;
<a name="l00071"></a>00071 
<a name="l00073"></a>00073         <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is...">StringVectorPtr</a> list(<span class="keywordtype">bool</span> recursive = <span class="keyword">true</span>, <span class="keywordtype">bool</span> dirs = <span class="keyword">false</span>);
<a name="l00074"></a>00074 
<a name="l00076"></a>00076         <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is...">FileInfoListPtr</a> listFileInfo(<span class="keywordtype">bool</span> recursive = <span class="keyword">true</span>, <span class="keywordtype">bool</span> dirs = <span class="keyword">false</span>);
<a name="l00077"></a>00077 
<a name="l00079"></a>00079         <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is...">StringVectorPtr</a> find(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; pattern, <span class="keywordtype">bool</span> recursive = <span class="keyword">true</span>,
<a name="l00080"></a>00080             <span class="keywordtype">bool</span> dirs = <span class="keyword">false</span>);
<a name="l00081"></a>00081 
<a name="l00083"></a>00083         <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is...">FileInfoListPtr</a> findFileInfo(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; pattern, <span class="keywordtype">bool</span> recursive = <span class="keyword">true</span>,
<a name="l00084"></a>00084             <span class="keywordtype">bool</span> dirs = <span class="keyword">false</span>);
<a name="l00085"></a>00085 
<a name="l00087"></a>00087         <span class="keywordtype">bool</span> exists(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; filename);
<a name="l00088"></a>00088     };
<a name="l00089"></a>00089 
<a name="l00091"></a><a class="code" href="classOgre_1_1ZipArchiveFactory.html">00091</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#f4c2f5df97e3050dd5266408be42db4b">_OgrePrivate</a> <a class="code" href="classOgre_1_1ZipArchiveFactory.html" title="Specialisation of ArchiveFactory for Zip files.">ZipArchiveFactory</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1ArchiveFactory.html" title="Abstract factory class, archive codec plugins can register concrete subclasses of...">ArchiveFactory</a>
<a name="l00092"></a>00092     {
<a name="l00093"></a>00093     <span class="keyword">public</span>:
<a name="l00094"></a><a class="code" href="classOgre_1_1ZipArchiveFactory.html#b1151aa6471ec8ff2be0f6555be51c8a">00094</a>         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1ZipArchiveFactory.html" title="Specialisation of ArchiveFactory for Zip files.">ZipArchiveFactory</a>() {}
<a name="l00096"></a>00096         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getType(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00098"></a><a class="code" href="classOgre_1_1ZipArchiveFactory.html#6cb4d739190da43608bcf7139c103e75">00098</a>         <a class="code" href="classOgre_1_1Archive.html" title="Archive-handling class.">Archive</a> *createInstance( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name ) 
<a name="l00099"></a>00099         {
<a name="l00100"></a>00100             <span class="keywordflow">return</span> <span class="keyword">new</span> <a class="code" href="classOgre_1_1ZipArchive.html" title="Specialisation of the Archive class to allow reading of files from a zip format source...">ZipArchive</a>(name, <span class="stringliteral">"Zip"</span>);
<a name="l00101"></a>00101         }
<a name="l00103"></a><a class="code" href="classOgre_1_1ZipArchiveFactory.html#78ccbf84f63fd51ef681bbbeacb383bd">00103</a>         <span class="keywordtype">void</span> destroyInstance( <a class="code" href="classOgre_1_1Archive.html" title="Archive-handling class.">Archive</a>* arch) { <span class="keyword">delete</span> arch; }
<a name="l00104"></a>00104     };
<a name="l00105"></a>00105 
<a name="l00107"></a><a class="code" href="classOgre_1_1ZipDataStream.html">00107</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#f4c2f5df97e3050dd5266408be42db4b">_OgrePrivate</a> <a class="code" href="classOgre_1_1ZipDataStream.html" title="Specialisation of DataStream to handle streaming data from zip archives.">ZipDataStream</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1DataStream.html" title="General purpose class used for encapsulating the reading of data.">DataStream</a>
<a name="l00108"></a>00108     {
<a name="l00109"></a>00109     <span class="keyword">protected</span>:
<a name="l00110"></a><a class="code" href="classOgre_1_1ZipDataStream.html#0114a4510ef5b5f5fc2e4767265c54e1">00110</a>         <a class="code" href="OgreZip_8h.html#83aee2653632d452e58ac776fde409ea">ZZIP_FILE</a>* mZzipFile;
<a name="l00111"></a>00111     <span class="keyword">public</span>:
<a name="l00113"></a>00113         <a class="code" href="classOgre_1_1ZipDataStream.html" title="Specialisation of DataStream to handle streaming data from zip archives.">ZipDataStream</a>(<a class="code" href="OgreZip_8h.html#83aee2653632d452e58ac776fde409ea">ZZIP_FILE</a>* zzipFile, <span class="keywordtype">size_t</span> uncompressedSize);
<a name="l00115"></a>00115         <a class="code" href="classOgre_1_1ZipDataStream.html" title="Specialisation of DataStream to handle streaming data from zip archives.">ZipDataStream</a>(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <a class="code" href="OgreZip_8h.html#83aee2653632d452e58ac776fde409ea">ZZIP_FILE</a>* zzipFile, <span class="keywordtype">size_t</span> uncompressedSize);
<a name="l00116"></a>00116         ~<a class="code" href="classOgre_1_1ZipDataStream.html" title="Specialisation of DataStream to handle streaming data from zip archives.">ZipDataStream</a>();
<a name="l00118"></a>00118         <span class="keywordtype">size_t</span> read(<span class="keywordtype">void</span>* buf, <span class="keywordtype">size_t</span> count);
<a name="l00120"></a>00120         <span class="keywordtype">void</span> skip(<span class="keywordtype">long</span> count);
<a name="l00122"></a>00122         <span class="keywordtype">void</span> seek( <span class="keywordtype">size_t</span> pos );
<a name="l00124"></a>00124         <span class="keywordtype">size_t</span> tell(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00126"></a>00126         <span class="keywordtype">bool</span> eof(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00128"></a>00128         <span class="keywordtype">void</span> close(<span class="keywordtype">void</span>);
<a name="l00129"></a>00129 
<a name="l00130"></a>00130 
<a name="l00131"></a>00131     };
<a name="l00132"></a>00132 
<a name="l00133"></a>00133 
<a name="l00134"></a>00134 }
<a name="l00135"></a>00135 
<a name="l00136"></a>00136 <span class="preprocessor">#endif</span>
</pre></div><hr>
<p>
Copyright &copy; 2000-2005 by The OGRE Team<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/"><img alt="Creative Commons License" border="0" src="http://creativecommons.org/images/public/somerights20.png"/></a><br/>
This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/">Creative Commons Attribution-ShareAlike 2.5 License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Mon Jun 16 12:48:57 2008
</p>
</body>
</html>
